<?php
require_once('/usr/local/lib64/webtools/config/config.php');
head();
right_boxes('news');
content();
?>

<?php
global $USER, $RUNAS_USER, $RUNAS_CMD, $CLUSTER, $TOOL_DISABLED, $GROUPAUDIT, $GROUPAUDIT_OPTS;

// setup greeting
$name = getFullName($USER);
if (isset($name))
    $greeting = "Hello, $name.";
else if (isset($USER))
    $greeting = "Hello, $USER.";
else
    $greeting = "Hello.";

// is the tool disabled? (i.e., is the audit over?)
if ($TOOL_DISABLED) {
    $year = date('Y');
    $ucluster = strtoupper($CLUSTER);
    print <<<HTML
    <div id='greeting'>$greeting</div>
    <br />
    The Spring $year, $ucluster Group Account and Virtual Host/Mail Domain Audit has ended. Group Accounts on $ucluster who did not complete the online renewal process will be closed.
    <p></p>
    If you have any questions, please contact <a href='mailto:help@rci.rutgers.edu'>help@rci.rutgers.edu</a> or the Help Desk at 732 445 HELP (4357).
HTML;
    foot();
    exit;
}

//lookup user become accounts
$state_arr = NULL;
$become_arr = NULL;
$has_priv = false;
$usercmd = "$GROUPAUDIT $GROUPAUDIT_OPTS $USER";
$exec_target = "$RUNAS_CMD $RUNAS_USER $usercmd";
exec($exec_target, $lines, $status);
if ($status == 0) {
    $current_become = NULL;
    foreach ($lines as $_ => $line) {
        // build multi-array
        if (strpos($line, '#') === false) {
            list($name, $value) = explode(':', $line);
            switch($name) {
                case 'become':
                    // init a new array key for this become account
                    $current_become = $value;
                    $become_arr[$current_become] = NULL;
                    break;
                case 'member':
                    // add members
                    $become_arr[$current_become][$name] = $value;
                    break;
                case 'mypriv':
                    // do we have at least one owner/admin priv?
                    if ($value == 'owner' || $value == 'admin')
                        $has_priv = true;

                    // add type of priv for this become
                    $become_arr[$current_become][$name] = $value;
                    break;
                case 'owners':
                    // add owner of this become
                    $become_arr[$current_become][$name] = $value;
                    break;
                case 'admins':
                    // add admin(s) of this become
                    $become_arr[$current_become][$name] = $value;
                    break;
                case 'vhosts':
                    $become_arr[$current_become][$name][] = $value;
                    break;
                case 'vmails':
                    $become_arr[$current_become][$name][] = $value;
                    break;
                case 'audits':
                    list($auditname, $action, $netid) = explode(',', $value);
                    $state_arr[$auditname]['action'] = $action;
                    $state_arr[$auditname]['netid'] = $netid;
                    break;
                default:
                    // found unrecognized output?
                    break;
            }
        }
    }
}

// nothing to audit for this user since they are NOT an owner or admin
if (! $has_priv) {
    print <<<HTML
    <div id='greeting'>$greeting</div>
    <br />
    According to our records you are NOT an owner or admin of any group account(s).
HTML;
    foot();
    exit;
}

// process become audit data we found
if (isset($become_arr) && is_array($become_arr)) {
    // encode and serialize the whole become account array for this user
    $serialized_become_arr = base64_encode(serialize($become_arr));

    $numtotal = 0;
    $numrequired = 0;
    $fieldsets = NULL;
    foreach ($become_arr as $become => $value_arr) {
        // we only care about owner(s) and admin(s)
        if (($mypriv = $value_arr['mypriv']) != 'member') {
            // keep track of total
            $numtotal++;

            // remove become name as member (in order to lessen confusion)
            $tmp_arr = explode(',', $value_arr['member']);
            $key = array_search($become, $tmp_arr);
            unset($tmp_arr[$key]);
           
            // build members line
            $owner_arr = array();
            $admin_arr = array();
            $member_arr = array();
            foreach ($tmp_arr as $_ => $member) {
                // owner?, admin?, or member?
                if ($value_arr['owners'] == $member)
                    $owner_arr[] = "$member (owner)";
                else if (strpos($value_arr['admins'], $member) !== false)
                    $admin_arr[] = "$member (admin)";
                else
                    $member_arr[] = $member;
            }

            // order members line as owner, admin(s), member(s)
            $members = implode(',', array_merge($owner_arr, $admin_arr, $member_arr));
    
            // find number of vhosts/vmails
            $numv = 0;
            if (isset($value_arr['vhosts']))
                $numv += count($value_arr['vhosts']);
            if (isset($value_arr['vmails']))
                $numv += count($value_arr['vmails']);
    
            // init the vhosts/vmails idnum (if necessary)
            if ($numv > 0)
                $idnum = 0;

            // set some defaults
            $star = '';
            $input_arr['become']['save'] = "<input id='{$become}_save' class='ba_groupradio' name='$become' type='radio' title='Choose to save group account $become' value='save' onclick=\"toggleVmailVhost('$become', 'save', '$numv')\" />";
            $input_arr['become']['delete'] = "<input id='{$become}_delete' class='ba_groupradio' name='$become' type='radio' title='Choose to delete group account $become' value='delete' onclick=\"toggleVmailVhost('$become', 'delete', '$numv')\" />";
            $label_arr['become']['save'] = "<label for='{$become}_save'>Save</label>";
            $label_arr['become']['delete'] = "<label for='{$become}_delete'>Delete</label>";

            // lookup current state (if any) according to our audit policy
            if (isset($state_arr[$become])) {
                $action = $state_arr[$become]['action'];
                $netid  = $state_arr[$become]['netid'];
                // has this USER performed the action? if so toggle it. (TOGGLE REGARDLESS OF USER)
                //if ($USER == $netid)
                $input_arr['become'][$action] = "<input id='{$become}_{$action}' class='ba_groupradio' name='$become' type='radio' title='Choose to $action group account $become' value='$action' checked='checked' onclick=\"toggleVmailVhost('$become', '$action', $numv)\" />";
    
                // determine whether owner or admin performed this action
                if ($netid == $value_arr['owners']) {
                    $label_arr['become'][$action] = "<label for='{$become}_{$action}'><b>".ucfirst($action)."</b> (is current status as per owner $netid)</label>";
                } else {
                    $label_arr['become'][$action] = "<label for='{$become}_{$action}'><b>".ucfirst($action)."</b> (is current status as per admin $netid and will be handled according to <a href='http://www.nbcs.rutgers.edu/newdocs/dept/dept.php3#Auditpolicy' target='_blank'>policy</a>)</label>";
                }
            } else {
                // requires action
                $numrequired++;
                $star = '*';
            }
           
            // build fieldset for become account
            $fieldsets .= <<<HTML
<p></p>
<fieldset id='$become-$numv' class='webtools'>
<legend class='webtools'>As $mypriv of group account <span class='ba_groupname'>$become</span></legend>
<span id='$become-$numv-error'></span>
<p class=''>Please choose to Save or Delete the following...</p>
<div class='ba_floatl'>
<p class='ba_groupname'><span class='required'>$star</span>$become:</p>
</div>
<div class='ba_clearl'>
{$input_arr['become']['save']}
{$label_arr['become']['save']}
</div>
<div class='ba_clearl'>
{$input_arr['become']['delete']}
{$label_arr['become']['delete']}
</div>
HTML;
            // any vhosts?
            if (isset($value_arr['vhosts'])) {
                // add vhost section
                $fieldsets .= <<<HTML
<p class='ba_vhosttext'>Virtual Host Domain(s) affiliated with <span class='ba_groupname'>$become</span></p>
HTML;
                foreach ($value_arr['vhosts'] as $_ => $vhost) {
                    $idnum++;
                    $input_arr['vhosts']['save'] = "<input id='{$become}{$idnum}_save' class='ba_vhostradio' name='$vhost' type='radio' title='Choose to save virtual host domain $vhost' value='save' />";
                    $input_arr['vhosts']['delete'] = "<input id='{$become}{$idnum}_delete' class='ba_vhostradio' name='$vhost' type='radio' title='Choose to delete virtual host domain $vhost' value='delete' />";
                    $label_arr['vhosts']['save'] = "<label for='{$become}{$idnum}_save'><span id='{$become}{$idnum}_saves'>Save</span></label>";
                    $label_arr['vhosts']['delete'] = "<label for='{$become}{$idnum}_delete'><span id='{$become}{$idnum}_deletes'>Delete</span></label>";
                    // lookup current state (if any) according to our audit policy
                    if (isset($state_arr[$vhost])) {
                        $action = $state_arr[$vhost]['action'];
                        $netid  = $state_arr[$vhost]['netid'];
    
                        // has this USER performed the action? if so toggle it. (TOGGLE REGARDLESS OF USER)
                        //if ($USER == $netid)
                        $input_arr['vhosts'][$action] = "<input id='{$become}{$idnum}_{$action}' class='ba_vhostradio' name='$vhost' type='radio' title='Choose to $action virtual host domain $vhost' value='$action' checked='checked' />";
    
                        // determine whether owner or admin performed this action
                        if ($netid == $value_arr['owners'])
                            $label_arr['vhosts'][$action] = "<label for='{$become}{$idnum}_{$action}'><span id='{$become}{$idnum}_{$action}s'><b>".ucfirst($action)."</b></span> (is current status as per owner $netid)</label>";
                        else
                            $label_arr['vhosts'][$action] = "<label for='{$become}{$idnum}_{$action}'><span id='{$become}{$idnum}_{$action}s'><b>".ucfirst($action)."</b></span> (is current status as per admin $netid and will be handled according to <a href='http://www.nbcs.rutgers.edu/newdocs/dept/dept.php3#Auditpolicy' target='_blank'>policy</a>)</label>";
                    }
    
                    $fieldsets .= <<<HTML
<div class='ba_floatl'>
<p class='ba_vhostname'><span class='required'>$star</span><a href="http://$vhost">http://$vhost</a>:</p>
</div>
<div class='ba_clearl'>
{$input_arr['vhosts']['save']}
{$label_arr['vhosts']['save']}
</div>
<div class='ba_clearl'>
{$input_arr['vhosts']['delete']}
{$label_arr['vhosts']['delete']}
</div>
<br />
HTML;
                }
            }

            // any vmails?
            if (isset($value_arr['vmails'])) {
                // add vmail section?
                $fieldsets .= <<<HTML
<p class='ba_vmailtext'>Virtual Mail Domain(s) affiliated with <span class='ba_groupname'>$become</span></p>
HTML;
                foreach ($value_arr['vmails'] as $_ => $vmail) {
                    $idnum++;
                    $input_arr['vmails']['save'] = "<input id='{$become}{$idnum}_save' class='ba_vmailradio' name='at-{$vmail}' type='radio' title='Choose to save virtual mail domain @$vmail' value='save' />";
                    $input_arr['vmails']['delete'] = "<input id='{$become}{$idnum}_delete' class='ba_vmailradio' name='at-{$vmail}' type='radio' title='Choose to delete virtual mail domain @$vmail' value='delete' />";
                    $label_arr['vmails']['save'] = "<label for='{$become}{$idnum}_save'><span id='{$become}{$idnum}_saves'>Save</span></label>";
                    $label_arr['vmails']['delete'] = "<label for='{$become}{$idnum}_delete'>Delete</label>";
                    // lookup current state (if any) according to our audit policy
                    if (isset($state_arr[$vmail])) {
                        $action = $state_arr[$vmail]['action'];
                        $netid  = $state_arr[$vmail]['netid'];
    
                        // has this USER performed the action? if so toggle it. (TOGGLE REGARDLESS OF USER)
                        //if ($USER == $netid)
                        $input_arr['vmails'][$action] = "<input id='{$become}{$idnum}_{$action}' class='ba_vmailradio' name='at-{$vmail}' type='radio' title='Choose to $action virtual mail domain @$vmail' value='$action' checked='checked' />";
    
                        if ($netid == $value_arr['owners'])
                            $label_arr['vmails'][$action] = "<label for='{$become}{$idnum}_{$action}'><span id='{$become}{$idnum}_{$action}s'><b>".ucfirst($action)."</b></span> (is current status as per owner $netid)</label>";
                        else
                            $label_arr['vmails'][$action] = "<label for='{$become}{$idnum}_{$action}'><span id='{$become}{$idnum}_{$action}s'><b>".ucfirst($action)."</b></span> (is current status as per admin $netid and will be handled according to <a href='http://www.nbcs.rutgers.edu/newdocs/dept/dept.php3#Auditpolicy' target='_blank'>policy</a>)</label>";
                    }

                    $fieldsets .= <<<HTML
<div class='ba_floatl'>
<p class='ba_vmailname'><span class='required'>$star</span>@$vmail:</p>
</div>
<div class='ba_clearl'>
{$input_arr['vmails']['save']}
{$label_arr['vmails']['save']}
</div>
<div class='ba_clearl'>
{$input_arr['vmails']['delete']}
{$label_arr['vmails']['delete']}
</div>
<br />
HTML;
                }
            }
            $fieldsets .= <<<HTML
<p class=''>Additionally, do any of these members $members <a href='https://www.rci.rutgers.edu/ratspriv/grouptool' target='_blank' title="If you click this link, you'll be taken to the grouptool to add or remove members. Log in with your NetID and select the account's name to manage its members.">need updating</a>?</p>
</fieldset>
HTML;
        }
    }
}

?>
<div id='greeting'><?=$greeting?></div>
<p>
Departmental, Organizational, Become, and Shared Accounts are all synonyms for
Group Accounts.  When a Group Account is created, the user who requested the
account was required to provide a NetID for the "owner" of the account.  The
"owner" is responsible for maintaining the group (e.g., adding members, 
removing members, etc...).  Additionally, the "owner" of the account can give
privileges to other members allowing them to share in the maintenance of 
the account.  These privileged members are also known as "admins".
</p>
<fieldset class='webtools'>
<legend class='webtools'>Group Account Audit Form</legend>
<span id='showchoices'></span>
<div id='groupfieldsets'>
According to our records you are an owner or admin of <?=$numtotal?> group account(s)
and any virtual host/mail domains affiliated with them. 
<br />
Currently no owner or admin has chosen to Save or Delete <?=$numrequired?> of those group accounts.
<p></p>
Please review the group accounts (along with any domains) below and choose to Save or Delete.
<p></p>
Be sure to submit by clicking the Submit button at the bottom of the page.
<br />
<input type='hidden' name='serialized_become_arr' value="<?=$serialized_become_arr?>" />
<?=$fieldsets?>
<br />
<input type='button' id='ba_sbutton' class='buttonWebtools' value='Submit' title='Submit audit choices' onclick="verify();submitChoices();" />
</div>
</fieldset>

<?php
foot();
?>
