<?php
require_once("/usr/local/lib64/webtools/config/config.php");
require_once("Mail.php");
?>

<?php
global $USER, $RUNAS_USER, $RUNAS_CMD, $CLUSTER, $AF, $MF, $FIND, $GROUPAUDIT_DIR;

// try and get some passed variables 
if (isset($_POST['choices']) && isset($_POST['sba'])) {
    $choices_arr = unserialize($_POST['choices']);
    $become_arr = unserialize(base64_decode($_POST['sba']));

    // timestamp to be prepended to each line outputted
    $w3cts = date('[' . DATE_W3C . ']');
    $epoch = date('[U]');
    $ucluster = strtoupper($CLUSTER);
    $emailoutput = "Thank you for responding to the $ucluster Group Account Audit.\nYou chose the following actions...\n";
    $htmloutput = NULL;
    foreach ($choices_arr as $_ => $line) {
        list($name, $value) = explode(':', $line);
        // is this a become account name OR vhost OR vmail?
        if (isset($become_arr[$name])) {
            // save and use this become name in case there are any associated vhosts or vmails 
            $becomename = $name;

            // we're dealing with a become account name
            $type = 'become';

            // init contents to be written
            $contents_arr[$becomename] = NULL;

            $htmlname = "\n$becomename";
        } else if (isset($become_arr[$becomename]['vhosts']) && in_array($name, $become_arr[$becomename]['vhosts'])) {
            // we're dealing with a vhost
            $type = 'vhosts';
            $htmlname = "http://$name";
        } else if (isset($become_arr[$becomename]['vmails'])) {
            // hack to remove "at-" from vmail name attribute
            $name = str_replace('at-', '', $name);

            if (in_array($name, $become_arr[$becomename]['vmails'])) {
                // we're dealing with a vmail
                $type = 'vmails';
                $htmlname = "@$name";
            }
        }

        // what are myprivs?
        $mypriv = $become_arr[$becomename]['mypriv'];

        // build the log file contents
        $contents_arr[$becomename] .= $epoch . ',' . $w3cts . ',' . $USER . ',' . $mypriv . ',' . $type . ',' . $name . ',' . $value . "\n";

        // build the email output
        $emailoutput .= "$htmlname: $value\n";
    }

    // write results to log
    foreach ($contents_arr as $becomename => $contents) {
        // does the file exist already?
        $usercmd = "$FIND $GROUPAUDIT_DIR/$becomename";
        $exec_target = "$RUNAS_CMD $RUNAS_USER $usercmd";
        exec($exec_target, $result, $status);
        if ($status == 0) {
            // append to the file
            $usercmd = "$AF -A $GROUPAUDIT_DIR/$becomename";
            $exec_target = "$RUNAS_CMD $RUNAS_USER $usercmd";
            $fp = popen($exec_target, 'w');
            fputs($fp, $contents);
            pclose($fp);
        } else {
            // create the file
            $usercmd = "$MF -A $GROUPAUDIT_DIR/$becomename";
            $exec_target = "$RUNAS_CMD $RUNAS_USER $usercmd";
            $fp = popen($exec_target, 'w');
            fputs($fp, $contents);
            pclose($fp);
        }
    }

    // send confirmation email
    $headers['From'] = "help@$CLUSTER.rutgers.edu";
    $headers['Subject'] = "$ucluster Group Account Audit Summary";
    $fullname = getFullname($USER);
    $emailbody = "$emailoutput\n";
    $emailbody .= "You may return to the $ucluster Group Account Audit webtool:\n\n"; 
    $emailbody .= "    {$_SERVER['HTTP_REFERER']}\n\n";

    $recipients['To'] = "$USER@rutgers.edu";
    $mail_object = &Mail::factory('mail');
    $result = $mail_object->send($recipients, $headers, $emailbody);
    if (PEAR::isError($result)) {
        $error = true;
        echo "Error: Failed sending confirmation mail to {$recipients['To']}, please contact 732-445-HELP.";
        echo "<span name='error' class='error'>Error: Failed sending confirmation mail to {$recipients['To']}. Please report this to your local Campus Computing Help Desk.</span><br />";
        exit;
    } else {
        $htmloutput = "Confirmation mail has been sent to {$recipients['To']}.<p>";
    }

    // convert the email output to html output
    $htmloutput .= nl2br($emailoutput);

    // print successful output
    echo "<span name='success' class='success'>$htmloutput</span>";
    exit;
}

// error out IFF we've made it this far
echo "<span name='error' class='error'>Error: Please report this to your local Campus Computing Help Desk.</span><br />";

?>
